Subject: A simple proposal for message/* and multipart/* content in Atom

From: "Brian Smith" <[email-masked]>
Date: Mon, 22 Sep 2008 17:31:52 -0500

My proposal is to create a new standards-track RFC that updates RFC 4287.
The RFC would say only this (plus the standard RFC boilerplate text):

   Abstract
   
      This document updates RFC 4287 to allow the
      atom:content's type attribute to have a
      composite MIME type. 

   Table of Contents
 
      1. All MIME types are allowed in atom:content .1
      2. References .................................1
         2.1 Normative References ...................1
      Appendix A. Contributors ......................1

   1. All MIME types are allowed in atom:content

      The restriction on atom:content's type
      attribute "but MUST NOT be a composite type"
      from section 4.1.3 in RFC 4287 is removed.
      There are now no restrictions on the type of
      content allowed in atom:content.

      The rules for processing atom:content remain
      exactly as specified in Section 4.1.3.3
      of [RFC4287]. In particular, when the 
      atom:content element contains content with
      a composite MIME type, that content must be
      encoded in Base64 as specified in step #6 of
      that section.      .
      
   9. References

      [RFC4287] Nottingham, M. and R. Sayre,
                "The Atom Syndication Format",
                RFC 4287, December 2005.      

   Appendix A.  Contributors

      The content and concepts within are a
      product of the Atom community and the
      AtomPub Working Group.
      
Background:
   
Recently, I have been working on an application for using AtomPub to archive
data--the client application watches for changed files on the local computer
and on the remote AtomPub server and ensures both of them stay in sync. It
is something like Microsoft's SyncToy.

I want to extend this to email, and I want to archive the email messages
unmodified in their message/rfc822 format. However, currently the Atom
specification forbids message/* and multipart/* in atom:content:

    On the atom:content element, the value of the
    "type" attribute MAY be one of "text", "html", or "xhtml".
    Failing that, it MUST conform to the syntax of a MIME
    media type, but MUST NOT be a composite type (see
    Section 4.2.6 of [MIMEREG]).

    - http://tools.ietf.org/html/rfc4287#section-4.1.3

   Multipart and message are composite types[.]

    - http://tools.ietf.org/html/rfc4288#section-4.2.6

Effectively, this means that if I want to archive email messages, I must
either violate RFC 4287 or I must use a non-standard MIME type for them.

I had a very similar problem archiving files that were saved using Internet
Explorer's MHT files (File > Save As > Web Archive, single file), which are
multipart/related.

Your feedback is much appreciated.

Regards,
Brian

---

From: "Thomas Broyer" <[email-masked]>
Date: Tue, 23 Sep 2008 01:48:32 +0200

To list... (sorry for the dupe Brian)

> The RFC would say only this (plus the standard RFC boilerplate text):

+1

> Explorer's MHT files (File > Save As > Web Archive, single file), which are

MHTML isn't IE-specific, it's a standards track RFC:
http://www.rfc-editor.org/rfc/rfc2557.txt
(and is natively supported by Opera 9.5 as well)

-- 
Thomas Broyer

---

From: Aristotle Pagaltzis <[email-masked]>
Date: Tue, 23 Sep 2008 02:44:30 +0200

* Brian Smith <[email-masked]> [2008-09-23 00:50]:
> The restriction on atom:content's type attribute "but MUST NOT
> be a composite type" from section 4.1.3 in RFC 4287 is removed.

+1

Regards,
-- 
Aristotle Pagaltzis // <http://plasmasturm.org/>